require "lib/path"

animals = {}

SpawnedAnimals = {}

function loadAnimals()
animals[1] = {}
animals[1].name = "raven"
animals[1].img = love.graphics.newImage(textureFolder .. "bird.png")
animals[1].forecolor = {0,0,0}
animals[1].PreferredHeight = 30
animals[1].PreferredTemperature = 10
animals[1].rarity = 6
animals[1].huntingMessage	= "trying to find some seeds to eat"
animals[1].eatingMessage	= "eating seeds"
animals[1].huntingID	   		= 5
animals[1].health				= 25
animals[1].strength				= 15
animals[1].character			= "passive"
animals[1].herbivore = true
animals[1].carnivore = false

animals[2] = {}
animals[2].name = "black bear"
animals[2].img = love.graphics.newImage(textureFolder .. "bear.png")
animals[2].forecolor = {0,0,0}
animals[2].PreferredHeight = 30
animals[2].PreferredTemperature = 15
animals[2].health				= 100
animals[2].strength				= 50
animals[2].rarity = 12
animals[2].huntingMessage	= "trying to find some salmon to eat"
animals[2].eatingMessage	= "hunting salmon"
animals[2].huntingID	   		= 2
animals[2].lootID = {}
animals[2].lootID[1]			= 23
animals[2].character			= "neutral"
animals[2].herbivore = false
animals[2].carnivore = true

animals[3] = {}
animals[3].name = "brown bear"
animals[3].img = love.graphics.newImage(textureFolder .. "bear.png")
animals[3].forecolor = {200,100,0}
animals[3].PreferredHeight = 30
animals[3].health				= 100
animals[3].PreferredTemperature = 15
animals[3].strength				= 50
animals[3].lootID = {}
animals[3].lootID[1]			= 23
animals[3].rarity = 8
animals[3].huntingMessage	= "trying to find some salmon to eat"
animals[3].eatingMessage	= "hunting salmon"
animals[3].huntingID	   		= 2
animals[3].character			= "neutral"
animals[3].herbivore = false
animals[3].carnivore = true

animals[4] = {}
animals[4].name = "cat"
animals[4].img = love.graphics.newImage(textureFolder .. "cat.png")
animals[4].forecolor = {200,150,0}
animals[4].PreferredHeight = 30
animals[4].PreferredTemperature = 15
animals[4].health				= 50
animals[4].strength				= 25
animals[4].rarity = 5
animals[4].huntingMessage	= "trying to find some rodents to eat"
animals[4].eatingMessage	= "hunting rodents"
animals[4].huntingID	   		= 5
animals[4].character			= "passive"
animals[4].herbivore = true
animals[4].carnivore = true

animals[5] = {}
animals[5].name = "lynx"
animals[5].img = love.graphics.newImage(textureFolder .. "cat.png")
animals[5].forecolor = {255,0,0}
animals[5].PreferredHeight = 30
animals[5].PreferredTemperature = -2
animals[5].health				= 50
animals[5].strength				= 25
animals[5].rarity = 5
animals[5].huntingMessage	= "trying to find some rodents to eat"
animals[5].eatingMessage	= "hunting rodents"
animals[5].huntingID	   		= 13
animals[5].character			= "neutral"
animals[5].herbivore = true
animals[5].carnivore = true

animals[6] = {}
animals[6].name = "scorpion"
animals[6].img = love.graphics.newImage(textureFolder .. "scorpion.png")
animals[6].forecolor = {100,100,0}
animals[6].PreferredHeight = 50
animals[6].PreferredTemperature = 40
animals[6].health				= 25
animals[6].strength				= 10
animals[6].lootID = {}
animals[6].lootID[1]			= 24
animals[6].rarity = 5
animals[6].huntingMessage	= "trying to find some bugs to eat"
animals[6].eatingMessage	= "eating some bugs"
animals[6].huntingID	   		= 15
animals[6].character			= "neutral"
animals[6].herbivore = true
animals[6].carnivore = true

animals[7] = {}
animals[7].name = "snake"
animals[7].img = love.graphics.newImage(textureFolder .. "snake.png")
animals[7].forecolor = {0,255,0}
animals[7].PreferredHeight = 50
animals[7].PreferredTemperature = 40
animals[7].health				= 25
animals[7].strength				= 25
animals[7].lootID				= {}
animals[7].lootID[1]			= 30
animals[7].rarity = 5
animals[7].huntingMessage	= "trying to find some rodents to eat"
animals[7].eatingMessage	= "hunting rodents"
animals[7].huntingID	   		= 15
animals[7].character			= "neutral"
animals[7].herbivore = true
animals[7].carnivore = true

animals[8] = {}
animals[8].name = "polar bear"
animals[8].img = love.graphics.newImage(textureFolder .. "bear.png")
animals[8].forecolor = {0,100,200}
animals[8].PreferredHeight = 30
animals[8].PreferredTemperature = -2
animals[8].health				= 100
animals[8].strength				= 50
animals[8].lootID = {}
animals[8].lootID[1]			= 23
animals[8].rarity = 8
animals[8].huntingMessage	= "trying to find some salmon to eat"
animals[8].eatingMessage	= "hunting on salmon"
animals[8].huntingID	   		= 14
animals[8].character			= "neutral"
animals[8].herbivore = false
animals[8].carnivore = true

animals[9] = {}
animals[9].name = "wolf"
animals[9].img = love.graphics.newImage(textureFolder .. "wolf.png")
animals[9].forecolor = {100,100,100}
animals[9].PreferredHeight = 30
animals[9].PreferredTemperature = 20
animals[9].health				= 50
animals[9].strength				= 25
animals[9].rarity = 8
animals[9].huntingMessage	= "trying to find some salmon to eat"
animals[9].eatingMessage	= "hunting on salmon"
animals[9].huntingID	   		= 14
animals[9].herbivore = false
animals[9].carnivore = true
animals[9].character			= "neutral"

animals[10] = {}
animals[10].name = "kobold"
animals[10].img = love.graphics.newImage(textureFolder .. "goblin.png")
animals[10].forecolor = {200,100,0}
animals[10].PreferredHeight 		= 30
animals[10].PreferredTemperature 	= 20
animals[10].health					= 100
animals[10].strength				= 50
animals[10].rarity = 8
animals[10].huntingID	   		= 14
animals[10].herbivore = false
animals[10].carnivore = true
animals[10].character			= "evil"

animals[10] = {}
animals[10].name = "goblin"
animals[10].img = love.graphics.newImage(textureFolder .. "goblin.png")
animals[10].forecolor = {50,150,0}
animals[10].PreferredHeight 		= 30
animals[10].PreferredTemperature 	= 20
animals[10].health					= 150
animals[10].strength				= 100
animals[10].lootID = {}
animals[10].lootID[1]			= 31
animals[10].rarity = 8
animals[10].huntingID	   		= 14
animals[10].herbivore = false
animals[10].carnivore = true
animals[10].character			= "evil"
end

function spawnEnemy(x,y)
	local newArray = {}
	for i = 1, #animals do
		if animals[i].character == "evil" then
			newArray[#newArray + 1] = i
		end
	end
	SpawnedAnimals[#SpawnedAnimals] =  NewAnimal(newArray[math.random(#newArray)])
	SpawnedAnimals[#SpawnedAnimals].x = x
	SpawnedAnimals[#SpawnedAnimals].y = y
end

function spawnAnimals()
SpawnedAnimals[1] = NewAnimal(1)
SpawnedAnimals[1].x = player.x
SpawnedAnimals[1].y = player.y
for x = 50, #World - 50 do
	for y = 50, #World[1] - 50 do
		for n = 1, #animals do
			if animals[n].character ~= "evil" then
			HeightScore 		=  math.abs(Chunk[x][y] - animals[n].PreferredHeight)
			TemperatureScore 	=  math.abs(Biomes[x][y] - animals[n].PreferredTemperature)
			Score = HeightScore + TemperatureScore
			if Score < 2 and math.random(animals[n].rarity) == 1 and tiles[World[x][y]].walkable then
				SpawnedAnimals[#SpawnedAnimals + 1] = NewAnimal(n)
				SpawnedAnimals[#SpawnedAnimals].x = x
				SpawnedAnimals[#SpawnedAnimals].y = y
				SpawnedAnimals[#SpawnedAnimals].POIx = x
				SpawnedAnimals[#SpawnedAnimals].POIy = y
			end
			end
		end
	end
end
end

function spawnEnemies()
SpawnedAnimals[1] = NewAnimal(1)
SpawnedAnimals[1].x = player.x
SpawnedAnimals[1].y = player.y
for x = 10, #World - 10 do
	for y = 10, #World[1] - 10 do
		for n = 1, #animals do
			if animals[n].character == "evil" then
			HeightScore 		=  math.abs(Chunk[x][y] - animals[n].PreferredHeight)
			TemperatureScore 	=  math.abs(Biomes[x][y] - animals[n].PreferredTemperature)
			Score = HeightScore + TemperatureScore
			if Score < 2 and math.random(animals[n].rarity) == 1 and tiles[World[x][y]].walkable then
				SpawnedAnimals[#SpawnedAnimals + 1] = NewAnimal(n)
				SpawnedAnimals[#SpawnedAnimals].x = x
				SpawnedAnimals[#SpawnedAnimals].y = y
				SpawnedAnimals[#SpawnedAnimals].POIx = x
				SpawnedAnimals[#SpawnedAnimals].POIy = y
			end
			end
		end
	end
end
end

function NewAnimal(ID)
A = {} 
A.ID					= ID
A.name  				= animals[ID].name 
A.img  					= animals[ID].img 
A.forecolor 			= animals[ID].forecolor
A.PreferredHeight 		= animals[ID].PreferredHeight
A.PreferredTemperature 	= animals[ID].PreferredTemperature 
A.commonness 			= animals[ID].commonness
A.thirst				= 25
A.hunger				= 25
A.activity				= "'nevermore'"
A.huntingMessage		= animals[ID].huntingMessage
A.eatingMessage			= animals[ID].eatingMessage
A.huntingID	   			= animals[ID].huntingID
A.health				= animals[ID].health
A.strength				= animals[ID].strength
A.character				= animals[ID].character
A.Angry					= animals[ID].Angry or false
A.ScaredOf 				= animals[ID].ScaredOf or false 
A.PoiID 				= {}
A.distracted 			= false
if animals[ID].lootID then
	A.lootID = {}
	for i = 1, #animals[ID].lootID do
		A.lootID[i] 			= animals[ID].lootID[i]
	end
end
return A
end

function updateAnimals(cameraX,cameraY,CameraWidth,CameraHeight,CollisionMap)
SmallMap = {}
for x = 1, CameraWidth do
	SmallMap[x] = {}
	for y = 1, CameraHeight do
		SmallMap[x][y] = CollisionMap[x + cameraX][y + cameraY]
	end
end

path = {}
pathfinder = Pathfinder(SmallMap)
local newArray = {}
for n = 1, #SpawnedAnimals do
 if not SpawnedAnimals[n].dead then
	newArray[#newArray + 1] = SpawnedAnimals[n]
 end
end
SpawnedAnimals = newArray

for n = 1, #SpawnedAnimals do
	if SpawnedAnimals[n].x > cameraX and
	SpawnedAnimals[n].y > cameraY and 
	SpawnedAnimals[n].x < cameraX + CameraWidth and 
	SpawnedAnimals[n].y < cameraY + CameraHeight then
	
	if SpawnedAnimals[n].character == "agressive" then
	SpawnedAnimals[n].Angry = true
	--battleBGM:play()
	StatusMessage = StatusMessage .. " " .. SpawnedAnimals[n].name .. " sees you as prey, and starts to attack you."
	elseif SpawnedAnimals[n].character == "evil" then
	SpawnedAnimals[n].Angry = true
	--battleBGM:play()
	StatusMessage = StatusMessage .. " " .. SpawnedAnimals[n].name .. " wants you dead."
	elseif SpawnedAnimals[n].character == "neutral" and 
	player.x < SpawnedAnimals[n].x + 3 and 
	player.x > SpawnedAnimals[n].x - 3 and 
	player.y < SpawnedAnimals[n].y + 3 and 
	player.y > SpawnedAnimals[n].y - 3 then 
	SpawnedAnimals[n].Angry = true
	--battleBGM:play()
	StatusMessage = StatusMessage .. " " .. SpawnedAnimals[n].name .. " feels provoked by you, and starts to defend itself."
	end
	
	
	--try to find a certain ID block
	SpawnedAnimals[n].thirst = SpawnedAnimals[n].thirst - 1
	SpawnedAnimals[n].hunger = SpawnedAnimals[n].hunger - 1
	SpawnedAnimals[n].POIx = SpawnedAnimals[n].x
	SpawnedAnimals[n].POIy = SpawnedAnimals[n].y
	if SpawnedAnimals[n].Angry then
	SpawnedAnimals[n].POIx = player.x
	SpawnedAnimals[n].POIy = player.y
	elseif SpawnedAnimals[n].thirst < 10  then
		SpawnedAnimals[n].activity = "trying to find water"
		SpawnedAnimals[n].PoiID = {}
		for i = 1, #tiles do
			if tiles[i].waterSource then
				SpawnedAnimals[n].PoiID[#SpawnedAnimals[n].PoiID + 1] = i
			end
		end 
	elseif SpawnedAnimals[n].hunger < 10 then
		if SpawnedAnimals[n].carnivore then
			for i = 1, #tiles do
				if tiles[i].carnivoreSource then
					SpawnedAnimals[n].PoiID[#SpawnedAnimals[n].PoiID + 1] = i
					SpawnedAnimals[n].activity = "trying to find " .. tiles[i].carnivoreType .. " in " .. tiles[i].name .. "."
				end
			end 
		end
		if SpawnedAnimals[n].herbivore then
			for i = 1, #tiles do
				if tiles[i].herbivoreSource then
					SpawnedAnimals[n].PoiID[#SpawnedAnimals[n].PoiID + 1] = i
					SpawnedAnimals[n].activity = "trying to find " .. tiles[i].herbivoreType .. " in " .. tiles[i].name .. "."
				end
			end 
		end
	else
		SpawnedAnimals[n].PoiID[1] = math.random(#tiles)
			if math.random(2) == 1 then
				SpawnedAnimals[n].activity = "wandering around. "
			else
				SpawnedAnimals[n].activity = "minding its own business. "
			end
	end


	secureCounter = 1
	if not SpawnedAnimals[n].Angry and
	#SpawnedAnimals[n].PoiID > 0 and
	SpawnedAnimals[n].PoiID and
	SpawnedAnimals[n].POIx and
	SpawnedAnimals[n].POIy and
	SpawnedAnimals[n].distracted == false and
	SpawnedAnimals[n].POIx > 25 and 
	SpawnedAnimals[n].POIy > 25 and 
	SpawnedAnimals[n].POIx < #World -25	and 
	SpawnedAnimals[n].POIy < #World[1] -25 and
	World[SpawnedAnimals[n].POIx][SpawnedAnimals[n].POIy] then
	for i = 1, #SpawnedAnimals[n].PoiID do 
	while World[SpawnedAnimals[n].POIx][SpawnedAnimals[n].POIy] ~= SpawnedAnimals[n].PoiID[i] do
	secureCounter = secureCounter + 1
	SpawnedAnimals[n].POIx = SpawnedAnimals[n].x + 10 - math.random(20)
	SpawnedAnimals[n].POIy = SpawnedAnimals[n].y + 10 - math.random(20)
	SpawnedAnimals[n].distracted = true
	if secureCounter > 10 then break end
	end
	end
	end
	if SpawnedAnimals[n].POIx and SpawnedAnimals[n].POIy then
	walk(SpawnedAnimals[n],SpawnedAnimals[n].POIx,SpawnedAnimals[n].POIy,cameraX,cameraY)
	end
end
end
end

function walk(Animal,GoalX,GoalY,cameraX,cameraY)
	pathfinder:find(Animal.x - cameraX, Animal.y - cameraY, GoalX - cameraX, GoalY - cameraY)
	path = pathfinder.path
	if #path > 1 then	
	Animal.vx = path[#path - 1].x - Animal.x + cameraX
	Animal.vy = path[#path - 1].y - Animal.y + cameraY
	
	NewX = math.ceil(Animal.x + Animal.vx * 1)
	NewY = math.ceil(Animal.y + Animal.vy * 1)
	
	ValidNewStep = true
	if player.x == NewX and player.y == NewY then
	ValidNewStep = false
	if Animal.Angry then
		local L = math.random(#player.limbs)
		StatusMessage = StatusMessage .. Animal.name .. " bites you in the " .. player.limbs[L].name .. ". "
		if Animal.strength - player.defense > 0 then
		player.limbs[L].health = player.limbs[L].health - (Animal.strength - player.defense)
		else
		StatusMessage = StatusMessage .. " but he couldn't pierce your armor."
		end
	end
	end
	for n = 1, #SpawnedAnimals do
		if SpawnedAnimals[n].x == NewX and SpawnedAnimals[n].y == NewY then ValidNewStep = false end
	end
	if Animal.ScaredOf and World[NewX][NewY] == Animal.ScaredOf then
		ValidNewStep = false
	end
	if ValidNewStep == true then
			Animal.x = NewX
			Animal.y = NewY
	end
	if tiles[World[NewX][NewY]].waterSource and Animal.thirst < 10 then
	 Animal.activity = "drinking from " .. tiles[World[NewX][NewY]].name .. ". "
	 Animal.thirst = 25
	 Animal.distracted = false
	end
	if Animal.Angry == true then
	 Animal.activity = "following you. "
	end
	if World[NewX][NewY] == Animal.huntingID and Animal.hunger < 10 then
		if Animal.carnivore and tiles[World[NewX][NewY]].carnivoreSource then
			Animal.activity = "eating " .. tiles[World[NewX][NewY]].carnivoreType " from " .. tiles[tiles[World[NewX][NewY]].carnivoreSource] .. ". "
		elseif Animal.herbivore and tiles[World[NewX][NewY]].herbivoreSource then
			Animal.activity = "eating " .. tiles[World[NewX][NewY]].herbivoreType " from " .. tiles[tiles[World[NewX][NewY]].herbivoreSource] .. ". "
		else
			Animal.activity = "eating. "
		end
	 Animal.hunger = 25
	 Animal.distracted = false
	end
else
Animal.distracted = false
end
end

function animalrayCast(animal,CamX,CamY)
CastedLines = {}
FieldOfView = {}
	for x = 1, #World do
		FieldOfView[x] = {}
		for y = 1, #World[1] do
			FieldOfView[x][y] = false
		end
	end
	for i = 1, 360 do
		CastedLines[i] = {}
		CastedLines[i].x = animal.x
		CastedLines[i].y = animal.y
		
		tempLength = 0.5
		endFound = false
		while tempLength < animal.lengthOfSight and endFound == false do
		if CastedLines[i].x > 1 and CastedLines[i].x < #World - 1 and
			CastedLines[i].y > 1 and CastedLines[i].y < #World[1] - 1 then
			if tiles[World[CastedLines[i].x][CastedLines[i].y]].lookthrough then
			CastedLines[i].x = math.floor(animal.x + 0.5 + math.cos(i) * tempLength)
			CastedLines[i].y = math.floor(animal.y + 0.5 + math.sin(i) * tempLength)
			FieldOfView[CastedLines[i].x][CastedLines[i].y] = true
			Discovered[CastedLines[i].x][CastedLines[i].y] = true
			tempLength = tempLength + 0.5
			else
			endFound = true
			end
		else
			endFound = true
		end
		
		end
	end
end
