player = {}
require 'data/items'
minute = (60 * 7) - 1
shownMinute = 1
shownHour = 1
shownDay = 1
shownMonth =  1
shownYear =  1

datenames = {}
datenames[1] = "zon"
datenames[2] = "maan"
datenames[3] = "blad"
datenames[4] = "water"
datenames[5] = "vuur"
datenames[6] = "bos"
datenames[7] = "gras"
datenames[8] = "zand"
datenames[9] = "bloem"
datenames[10] = "duin"
datenames[11] = "berg"
datenames[12] = "boom"
datenames[13] = "berk"
datenames[14] = "den"
datenames[15] = "beuk"

months = {}
months[1] = "LENTE"
months[2] = "ZOMER"
months[3] = "HERFST"
months[4] = "WINTER"

achievements = {}
achievements[1] = {}
achievements[1].name = "Make an axe and pickaxe."
achievements[1].description = "First thing you want to do to survive is create yourself an axe and pickaxe from rock. You can find rocks almost anywhere, just dig in sand or under grass with [SPACE] to find some. Now you can go to your crafting menu with [C] and craft both of them."
achievements[1].requirementBlueprintID = {}
achievements[1].requirementBlueprintAmount = {}
achievements[1].requirementBlueprintID[1] = {1}
achievements[1].requirementBlueprintID[2] = {2,3,4}
achievements[1].requirementBlueprintAmount[1] = 1
achievements[1].requirementBlueprintAmount[2] = 1

achievements[2] = {}
achievements[2].name = "Kill an animal and cook the food."
achievements[2].description = "Your biggest priority if you want to survive is eating. Teach yourself how to get yourself meat and prepare it on a campfire or iron cooking pot."
achievements[2].requirementBlueprintID = {}
achievements[2].requirementBlueprintAmount = {}
achievements[2].requirementBlueprintID[1] = {22}
achievements[2].requirementBlueprintAmount[1] = 1

achievements[3] = {}
achievements[3].name = "Build shelter with a door."
achievements[3].description = "To be able to survive the night, you should create shelter. Create walls and a door from wood or stone."
achievements[3].requirementBlueprintID = {}
achievements[3].requirementBlueprintAmount = {}
achievements[3].requirementBlueprintID[1] = {46,48,83,84,85,11,12,16}
achievements[3].requirementBlueprintAmount[1] = 10
achievements[3].requirementBlueprintID[2] = {44,45,47,86,87,88,14,21}
achievements[3].requirementBlueprintAmount[2] = 1

achievements[4] = {}
achievements[4].name = "Create a chest."
achievements[4].description = "You can't carry everything you want with you all the time! That'd be too heavy! Create a chest and relieve some weight by putting some of your items in a chest."
achievements[4].requirementBlueprintID = {}
achievements[4].requirementBlueprintAmount = {}
achievements[4].requirementBlueprintID[1] = {80,81,82}
achievements[4].requirementBlueprintAmount[1] = 1

achievements[5] = {}
achievements[5].name = "Start some agriculture!"
achievements[5].description = "In order to be self sufficient, you need to start a farm. Collect tomato, cabbage and eggplants, make seedlings out of them and plant them!"
achievements[5].requirementBlueprintID = {}
achievements[5].requirementBlueprintAmount = {}
achievements[5].requirementBlueprintID[1] = {39}
achievements[5].requirementBlueprintAmount[1] = 1
achievements[5].requirementBlueprintID[2] = {61}
achievements[5].requirementBlueprintAmount[2] = 1
achievements[5].requirementBlueprintID[3] = {64}
achievements[5].requirementBlueprintAmount[3] = 1

achievements[5] = {}
achievements[5].name = "Create armor!"
achievements[5].description = "If you want to get the least amount of damage, you need some better armor! Find adamantium and craft armor from it!"
achievements[5].requirementBlueprintID = {}
achievements[5].requirementBlueprintAmount = {}
achievements[5].requirementBlueprintID[1] = {111}
achievements[5].requirementBlueprintAmount[1] = 1
achievements[5].requirementBlueprintID[2] = {112}
achievements[5].requirementBlueprintAmount[2] = 1
achievements[5].requirementBlueprintID[3] = {113}
achievements[5].requirementBlueprintAmount[3] = 1
achievements[5].requirementBlueprintID[4] = {114}
achievements[5].requirementBlueprintAmount[4] = 1


function player_load()
player.inventory = {}
player.crafts = {}
player.equippedTool = 0
player.dexterity = 10
player.strength = 10
player.survival = 10
player.endurance = 10
player.health = 100

player.vest = false
player.pants = false
player.helmet = false
player.shoes = false
player.gloves = false
player.defense = 1

player.achievements = {}
for a = 1, #achievements do
	player.achievements[a] = false
end
achievementSelection = 1

player.lengthOfSightMAX = 15
player.lengthOfSight = 15
player.onDrugs = false
player.minutesOnDrugs = 0
player.minutesuntilSober = 0
player.limbs = {}
player.limbs[1] = {}
player.limbs[1].name = "face"
player.limbs[1].perk = "perception"
player.limbs[1].health = player.endurance * 10
player.limbs[1].maxHealth = player.endurance * 10
player.limbs[2] = {}
player.limbs[2].name = "body"
player.limbs[2].perk = "health"
player.limbs[2].health = player.endurance * 10
player.limbs[2].maxHealth = player.endurance * 10
player.limbs[3] = {}
player.limbs[3].name = "arm"
player.limbs[3].perk = "actions"
player.limbs[3].health = player.endurance * 10
player.limbs[3].maxHealth = player.endurance * 10
player.limbs[4] = {}
player.limbs[4].name = "leg"
player.limbs[4].perk = "movement"
player.limbs[4].health = player.endurance * 10
player.limbs[4].maxHealth = player.endurance * 10

for i = 1, #items do
	player.inventory[i] = 0
end

player.x = 1
player.y = 1
if not playerCustomImage then playerCustomImage = textureFolder .. "player.png" end
player.img = love.graphics.newImage(playerCustomImage)
playerSprite = player.img
Discovered = {}
FieldOfLight = {}
	for x = 1, #currentLevel do
		Discovered[x] = {}
		FieldOfLight[x] = {}
		for y = 1, #currentLevel[1] do
			Discovered[x][y] = false
			FieldOfLight[x][y] = false
		end
	end
	
player_update()
end

function player_newLocation()
player.x = math.random(#currentLevel) 
player.y = math.random(#currentLevel[1])
selectedTile[1]	= player.x
selectedTile[2] = player.y
end

function player_update()
player.defense = 1
if player.vest then
player.defense = player.defense + blueprints[player.vest].defense
end
if player.pants then
player.defense = player.defense + blueprints[player.pants].defense
end
if player.helmet then
player.defense = player.defense + blueprints[player.helmet].defense
end
if player.shoes then
player.defense = player.defense + blueprints[player.shoes].defense
end
if player.gloves then
player.defense = player.defense + blueprints[player.gloves].defense
end

for i = 1, #achievements do
	requirementsGotten = {}
	for r = 1, #achievements[i].requirementBlueprintID do
			requirementsGotten[r] = 0
	end
	for c = 1, #player.crafts do
		for r = 1, #achievements[i].requirementBlueprintID do
			for a = 1, #achievements[i].requirementBlueprintID[r] do
				if achievements[i].requirementBlueprintID[r][a] == player.crafts[c] then
					requirementsGotten[r] = requirementsGotten[r] + 1
					
				end
			end
		end
	end
	achievementGotten = true
	for r = 1, #requirementsGotten do
		if requirementsGotten[r] < achievements[i].requirementBlueprintAmount[r] then
			achievementGotten = false
		end
		print("got " .. requirementsGotten[r] .. " of "  .. achievements[i].requirementBlueprintAmount[r])
	end
	if achievementGotten == true then
		player.achievements[i] = true
		print("achievement got!")
	end
end

minute = minute + 1
shownDay = 1
shownMinute = 0
shownMonth = 1
shownHour = 1
shownYear = 1
if player.onDrugs then
	player.minutesOnDrugs = player.minutesOnDrugs + 1
		if player.minutesOnDrugs > player.minutesuntilSober then
			player.minutesOnDrugs = 0
			player.onDrugs = false
			StatusMessage = StatusMessage .. " the drugs have worn off."
		end
end
for m = 1, minute do
	shownMinute = shownMinute + 1
	if shownMinute > 59 then
	shownMinute = 0
	shownHour = shownHour + 1
	end
	if shownHour > 23 then
	shownHour = 0
	shownDay = shownDay + 1
	end
	if shownDay > 15 then
		shownDay = 1
		shownMonth = shownMonth + 1
	end
	if shownMonth > 4 then
		shownMonth = 1
		shownYear = shownYear + 1
	end
end
if shownMinute < 10 then shownMinute = "0" .. shownMinute end
if shownMinute == 60 then shownMinute = "00" end
if shownHour < 10 then shownHour = "0" .. shownHour end
if shownHour == 24 then shownHour = "00" end
totalhealth = 0
for L = 1, #player.limbs do
		player.limbs[L].maxHealth = player.endurance * 10
		if player.limbs[L].health < 1 then
		 StatusMessage = StatusMessage .. " Your " .. player.limbs[L].name .. " is crippled!"
		end
	totalhealth = math.floor(totalhealth + player.limbs[L].health)
end
player.lengthOfSight = math.ceil(player.lengthOfSightMAX / 100 * player.limbs[1].health)
player.lengthOfSight = player.lengthOfSight * (1 - (math.abs(shownHour - 12) / 20))
if player.lengthOfSight < 1 then player.lengthOfSight = 1 end
player.health = math.floor(totalhealth / #player.limbs)
updateAgriculture()
end

function player_rayCast(CamX,CamY,CamWidth,CamHeight)
CastedLines = {}
FieldOfView = {}
	for x = CamX, CamX + CamWidth do
		FieldOfView[x] = {}
		for y = CamY, CamY + CamHeight do
			FieldOfView[x][y] = false
		end
	end
	for i = 1, 360 do
		CastedLines[i] = {}
		CastedLines[i].x = player.x
		CastedLines[i].y = player.y
		
		tempLength = 0.5
		endFound = false
		while tempLength < player.lengthOfSight and endFound == false do
		if CastedLines[i].x > 1 and CastedLines[i].x < #currentLevel - 1 and
			CastedLines[i].y > 1 and CastedLines[i].y < #currentLevel[1] - 1 then
			if tiles[currentLevel[CastedLines[i].x][CastedLines[i].y]].lookthrough then
			CastedLines[i].x = math.floor(player.x + 0.5 + math.cos(i) * tempLength)
			CastedLines[i].y = math.floor(player.y + 0.5 + math.sin(i) * tempLength)
			FieldOfView[CastedLines[i].x][CastedLines[i].y] = true
			Discovered[CastedLines[i].x][CastedLines[i].y] = true
			tempLength = tempLength + 0.5
			else
			endFound = true
			end
		else
			endFound = true
		end
		
		end
	end
end

