tiles = {}

function loadTiles()
tiles[1] = {}
tiles[1].name = "deep water"
tiles[1].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[1].forecolor = {0,0,200}
tiles[1].backcolor = {0,0,150}
tiles[1].walkable = false
tiles[1].PreferredHeight = 10
tiles[1].PreferredTemperature = 0
tiles[1].rarity = 1
tiles[1].lookthrough = true
tiles[1].breakable = false
tiles[1].waterSource = true
tiles[1].ReplacementID = 3
tiles[1].carnivoreSource = true
tiles[1].carnivoreType = "salmon"
tiles[1].herbivoreSource = true
tiles[1].herbivoreSource = "seaweed"

tiles[2] = {}
tiles[2].name = "shallow water"
tiles[2].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[2].forecolor = {0,100,255}
tiles[2].backcolor = {0,50,200}
tiles[2].walkable = true
tiles[2].PreferredHeight = 20
tiles[2].PreferredTemperature = 5
tiles[2].rarity = 1
tiles[2].lookthrough = true
tiles[2].breakable = false
tiles[2].waterSource = true
tiles[2].ReplacementID = 3
tiles[2].carnivoreSource = true
tiles[2].carnivoreType = "salmon"
tiles[2].herbivoreSource = true
tiles[2].herbivoreSource = "seaweed"

tiles[3] = {}
tiles[3].name = "mud"
tiles[3].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[3].forecolor = {255,200,0}
tiles[3].backcolor = {200,150,0}
tiles[3].walkable = true
tiles[3].PreferredHeight = 25
tiles[3].PreferredTemperature = 1
tiles[3].rarity = 1
tiles[3].lookthrough = true
tiles[3].breakable = true
tiles[3].ReplacementID = 22
tiles[3].lootID = 1
tiles[3].lootAmount = 2



tiles[4] = {}
tiles[4].name = "sand"
tiles[4].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[4].forecolor = {255,255,0}
tiles[4].backcolor = {200,200,0}
tiles[4].walkable = true
tiles[4].PreferredHeight = 25
tiles[4].PreferredTemperature = 10
tiles[4].rarity = 1
tiles[4].lookthrough = true
tiles[4].breakable = true
tiles[4].ReplacementID = 22
tiles[4].lootID = 2
tiles[4].lootAmount = 3
tiles[4].carnivoreSource = true
tiles[4].carnivoreType = "crabs"



tiles[5] = {}
tiles[5].name = "grass"
tiles[5].img = love.graphics.newImage(textureFolder .. "grass.png")
tiles[5].forecolor = {0,255,0}
tiles[5].backcolor = {0,200,0}
tiles[5].walkable = true
tiles[5].PreferredHeight = 30
tiles[5].PreferredTemperature = 10
tiles[5].rarity = 1
tiles[5].lookthrough = true
tiles[5].breakable = true
tiles[5].ReplacementID = 22
tiles[5].lootID = 3
tiles[5].lootAmount = 4
tiles[5].herbivoreSource = true
tiles[5].herbivoreSource = "grass"

tiles[6] = {}
tiles[6].name = "beech"
tiles[6].img = love.graphics.newImage(textureFolder .. "tree.png")
tiles[6].forecolor = {0,100,0}
tiles[6].backcolor = {0,200,0}
tiles[6].walkable = false
tiles[6].PreferredHeight = 30
tiles[6].PreferredTemperature = 20
tiles[6].rarity = 6
tiles[6].lookthrough = false
tiles[6].breakable = true
tiles[6].toolNeeded = "axe"
tiles[6].ReplacementID = 5
tiles[6].lootID = 4
tiles[6].lootAmount = 3
tiles[6].carnivoreSource = true
tiles[6].carnivoreType = "birds"
tiles[6].herbivoreSource = true
tiles[6].herbivoreSource = "leaves"

tiles[7] = {}
tiles[7].name = "slate mountains"
tiles[7].img = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[7].forecolor = {200,200,200}
tiles[7].backcolor = {150,150,150}
tiles[7].walkable = false
tiles[7].PreferredHeight = 90
tiles[7].PreferredTemperature = 10
tiles[7].rarity = 1
tiles[7].lookthrough = false
tiles[7].breakable = true
tiles[7].toolNeeded = "pickaxe"
tiles[7].ReplacementID = 22
tiles[7].lootID = 5
tiles[7].lootAmount = 4

tiles[8] = {}
tiles[8].name = "snowy mountains"
tiles[8].img = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[8].forecolor = {255,255,255}
tiles[8].backcolor = {200,200,200}
tiles[8].walkable = false
tiles[8].PreferredHeight = 100
tiles[8].PreferredTemperature = 10
tiles[8].rarity = 1
tiles[8].lookthrough = false
tiles[8].breakable = true
tiles[8].toolNeeded = "pickaxe"
tiles[8].ReplacementID = 13
tiles[8].lootID = 5
tiles[8].lootAmount = 4

tiles[9] = {}
tiles[9].name = "red rose"
tiles[9].img = love.graphics.newImage(textureFolder .. "cross.png")
tiles[9].forecolor = {255,0,0}
tiles[9].backcolor = {0,200,0}
tiles[9].walkable = true
tiles[9].PreferredHeight = 30
tiles[9].PreferredTemperature = 20
tiles[9].rarity = 5
tiles[9].lookthrough = true
tiles[9].breakable = true
tiles[9].ReplacementID = 5
tiles[9].lootID = 3
tiles[9].lootAmount = 2
tiles[9].carnivoreSource = true
tiles[9].carnivoreType = "bees"
tiles[9].herbivoreSource = true
tiles[9].herbivoreSource = "leaves"

tiles[10] = {}
tiles[10].name = "white lily"
tiles[10].img = love.graphics.newImage(textureFolder .. "cross.png")
tiles[10].forecolor = {255,255,255}
tiles[10].backcolor = {0,200,0}
tiles[10].walkable = true
tiles[10].PreferredHeight = 30
tiles[10].PreferredTemperature = 20
tiles[10].rarity = 5
tiles[10].lookthrough = true
tiles[10].breakable = true
tiles[10].ReplacementID = 5
tiles[10].lootID = 3
tiles[10].lootAmount = 2
tiles[10].carnivoreSource = true
tiles[10].carnivoreType = "bees"
tiles[10].herbivoreSource = true
tiles[10].herbivoreSource = "leaves"

tiles[11] = {}
tiles[11].name = "snowy pine tree"
tiles[11].img = love.graphics.newImage(textureFolder .. "pine.png")
tiles[11].forecolor = {0,150,0}
tiles[11].backcolor = {255,255,255}
tiles[11].walkable = false
tiles[11].PreferredHeight = 30
tiles[11].PreferredTemperature = 0
tiles[11].rarity = 5
tiles[11].lookthrough = false
tiles[11].breakable = true
tiles[11].toolNeeded = "axe"
tiles[11].ReplacementID = 13
tiles[11].lootID = 13
tiles[11].lootAmount = 3

tiles[12] = {}
tiles[12].name = "birch tree"
tiles[12].img = love.graphics.newImage(textureFolder .. "oak.png")
tiles[12].forecolor = {100,255,100}
tiles[12].backcolor = {0,200,0}
tiles[12].walkable = false
tiles[12].PreferredHeight = 40
tiles[12].PreferredTemperature = 10
tiles[12].rarity = 3
tiles[12].lookthrough = false
tiles[12].breakable = true
tiles[12].toolNeeded = "axe"
tiles[12].ReplacementID = 5
tiles[12].lootID = 12
tiles[12].lootAmount = 3

tiles[13] = {}
tiles[13].name = "snow"
tiles[13].img = love.graphics.newImage(textureFolder .. "grass.png")
tiles[13].forecolor = {0,150,0}
tiles[13].backcolor = {255,255,255}
tiles[13].walkable = true
tiles[13].PreferredHeight = 30
tiles[13].PreferredTemperature = -2
tiles[13].rarity = 1
tiles[13].lookthrough = true
tiles[13].breakable = true
tiles[13].ReplacementID = 3
tiles[13].waterSource = true
tiles[13].lootID = 2
tiles[13].lootAmount = 3
tiles[13].carnivoreSource = true
tiles[13].carnivoreType = "rodents"
tiles[13].herbivoreSource = true
tiles[13].herbivoreSource = "bugs"

tiles[14] = {}
tiles[14].name = "ice"
tiles[14].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[14].forecolor = {0,255,255}
tiles[14].backcolor = {100,255,255}
tiles[14].walkable = true
tiles[14].PreferredHeight = 20
tiles[14].PreferredTemperature = -2
tiles[14].rarity = 1
tiles[14].lookthrough = true
tiles[14].breakable = false
tiles[14].waterSource = true
tiles[14].ReplacementID = 5
tiles[14].carnivoreSource = true
tiles[14].carnivoreType = "salmon"

tiles[15] = {}
tiles[15].name = "red sand"
tiles[15].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[15].forecolor = {255,50,0}
tiles[15].backcolor = {200,50,0}
tiles[15].walkable = true
tiles[15].PreferredHeight = 50
tiles[15].PreferredTemperature = 40
tiles[15].rarity = 1
tiles[15].lookthrough = true
tiles[15].breakable = true
tiles[15].ReplacementID = 22
tiles[15].lootID = 6
tiles[15].lootAmount = 3
tiles[15].carnivoreSource = true
tiles[15].carnivoreType = "rodents"

tiles[16] = {}
tiles[16].name = "dunes"
tiles[16].img = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[16].forecolor = {255,200,0}
tiles[16].backcolor = {200,50,0}
tiles[16].walkable = false
tiles[16].PreferredHeight = 40
tiles[16].PreferredTemperature = 40
tiles[16].rarity = 1
tiles[16].lookthrough = false
tiles[16].breakable = true
tiles[16].ReplacementID = 15
tiles[16].lootID = 6
tiles[16].lootAmount = 8


tiles[17] = {}
tiles[17].name = "coal"
tiles[17].img = love.graphics.newImage(textureFolder .. "ore.png")
tiles[17].backImg = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[17].forecolor = {0,0,0}
tiles[17].backcolor = {150,150,150}
tiles[17].walkable = false
tiles[17].PreferredHeight = 90
tiles[17].PreferredTemperature = 10
tiles[17].rarity = 7
tiles[17].lookthrough = false
tiles[17].breakable = true
tiles[17].toolNeeded = "pickaxe"
tiles[17].ReplacementID = 7
tiles[17].lootID = 7
tiles[17].lootAmount = 3

tiles[18] = {}
tiles[18].name = "dense grass"
tiles[18].img = love.graphics.newImage(textureFolder .. "densegrass.png")
tiles[18].forecolor = {0,150,0}
tiles[18].backcolor = {0,200,0}
tiles[18].walkable = true
tiles[18].PreferredHeight = 30
tiles[18].PreferredTemperature = 20
tiles[18].rarity = 1
tiles[18].lookthrough = true
tiles[18].breakable = true
tiles[18].ReplacementID = 22
tiles[18].lootID = 3
tiles[18].lootAmount = 4
tiles[18].herbivoreSource = true
tiles[18].herbivoreSource = "grass"

tiles[19] = {}
tiles[19].name = "iron"
tiles[19].img = love.graphics.newImage(textureFolder .. "ore.png")
tiles[19].backImg = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[19].forecolor = {255,100,100}
tiles[19].backcolor = {150,150,150}
tiles[19].walkable = false
tiles[19].PreferredHeight = 80
tiles[19].PreferredTemperature = 30
tiles[19].rarity = 8
tiles[19].lookthrough = false
tiles[19].breakable = true
tiles[19].toolNeeded = "pickaxe"
tiles[19].ReplacementID = 7
tiles[19].lootID = 9
tiles[19].lootAmount = 3

tiles[20] = {}
tiles[20].name = "gold"
tiles[20].img = love.graphics.newImage(textureFolder .. "ore.png")
tiles[20].backImg = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[20].forecolor = {255,255,0}
tiles[20].backcolor = {200,50,0}
tiles[20].walkable = false
tiles[20].PreferredHeight = 42
tiles[20].PreferredTemperature = 40
tiles[20].rarity = 14
tiles[20].lookthrough = false
tiles[20].breakable = true
tiles[20].toolNeeded = "pickaxe"
tiles[20].ReplacementID = 7
tiles[20].lootID = 10
tiles[20].lootAmount = 3

tiles[21] = {}
tiles[21].name = "emerald"
tiles[21].img = love.graphics.newImage(textureFolder .. "ore.png")
tiles[21].backImg = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[21].forecolor = {0,255,0}
tiles[21].backcolor = {150,150,150}
tiles[21].walkable = false
tiles[21].PreferredHeight = 90
tiles[21].PreferredTemperature = 30
tiles[21].rarity = 20
tiles[21].lookthrough = false
tiles[21].breakable = true
tiles[21].toolNeeded = "pickaxe"
tiles[21].ReplacementID = 7
tiles[21].lootID = 11
tiles[21].lootAmount = 3

tiles[22] = {}
tiles[22].name = "rocks"
tiles[22].img = love.graphics.newImage(textureFolder .. "pebbles.png")
tiles[22].forecolor = {200,200,200}
tiles[22].backcolor = {150,150,150}
tiles[22].walkable = true
tiles[22].PreferredHeight = 50
tiles[22].PreferredTemperature = 30
tiles[22].rarity = 15
tiles[22].lookthrough = true
tiles[22].breakable = true
tiles[22].ReplacementID = 22
tiles[22].lootID = 14
tiles[22].lootAmount = 3
tiles[22].carnivoreSource = true
tiles[22].carnivoreType = "bugs"
tiles[22].herbivoreSource = true
tiles[22].herbivoreSource = "bugs"

tiles[23] = {}
tiles[23].name = "cactus"
tiles[23].img = love.graphics.newImage(textureFolder .. "cactus.png")
tiles[23].forecolor = {50,255,50}
tiles[23].backcolor = {200,50,0}
tiles[23].walkable = true
tiles[23].PreferredHeight = 60
tiles[23].PreferredTemperature = 40
tiles[23].rarity = 10
tiles[23].lookthrough = true
tiles[23].waterSource = true
tiles[23].breakable = true
tiles[23].ReplacementID = 15
tiles[23].herbivoreSource = true
tiles[23].herbivoreSource = "bugs"

tiles[24] = {}
tiles[24].name = "beech wooden wall"
tiles[24].img = love.graphics.newImage(textureFolder .. "wood.png")
tiles[24].forecolor = {200,150,0}
tiles[24].backcolor = {100,50,0}
tiles[24].walkable = false
tiles[24].lookthrough = false
tiles[24].waterSource = false
tiles[24].artificial = true
tiles[24].breakable = true
tiles[24].toolNeeded = "axe"
tiles[24].ReplacementID = 22
tiles[24].lootID = 4
tiles[24].lootAmount = 5

tiles[25] = {}
tiles[25].name = "pine wooden wall"
tiles[25].img = love.graphics.newImage(textureFolder .. "wood.png")
tiles[25].forecolor = {200,180,0}
tiles[25].backcolor = {100,75,0}
tiles[25].walkable = false
tiles[25].lookthrough = false
tiles[25].waterSource = false
tiles[25].artificial = true
tiles[25].breakable = true
tiles[25].toolNeeded = "axe"
tiles[25].ReplacementID = 22
tiles[25].lootID = 13
tiles[25].lootAmount = 5

tiles[26] = {}
tiles[26].name = "glass Pane (green)"
tiles[26].img = love.graphics.newImage(textureFolder .. "glass.png")
tiles[26].forecolor = {0,150,0}
tiles[26].backcolor = {100,255,100}
tiles[26].walkable = false
tiles[26].lookthrough = true
tiles[26].waterSource = false
tiles[26].artificial = true
tiles[26].breakable = true
tiles[26].toolNeeded = "pickaxe"
tiles[26].ReplacementID = 22
tiles[26].lootID = 2
tiles[26].lootAmount = 5

tiles[27] = {}
tiles[27].name = "glass Pane (red)"
tiles[27].img = love.graphics.newImage(textureFolder .. "glass.png")
tiles[27].forecolor = {150,0,0}
tiles[27].backcolor = {255,100,100}
tiles[27].walkable = false
tiles[27].lookthrough = true
tiles[27].waterSource = false
tiles[27].artificial = true
tiles[27].breakable = true
tiles[27].toolNeeded = "pickaxe"
tiles[27].ReplacementID = 22
tiles[27].lootID = 6
tiles[27].lootAmount = 5

tiles[28] = {}
tiles[28].name = "door (closed)"
tiles[28].img = love.graphics.newImage(textureFolder .. "doorclosed.png")
tiles[28].forecolor = {200,180,0}
tiles[28].backcolor = {100,75,0}
tiles[28].walkable = false
tiles[28].lookthrough = false
tiles[28].waterSource = false
tiles[28].artificial = true
tiles[28].breakable = true
tiles[28].toolNeeded = "axe"
tiles[28].switchID = 29
tiles[28].ReplacementID = 22
tiles[28].lootID = 4
tiles[28].lootAmount = 5

tiles[29] = {}
tiles[29].name = "door (open)"
tiles[29].img = love.graphics.newImage(textureFolder .. "dooropen.png")
tiles[29].forecolor = {200,180,0}
tiles[29].backcolor = {100,75,0}
tiles[29].walkable = true
tiles[29].lookthrough = true
tiles[29].waterSource = false
tiles[29].artificial = true
tiles[29].breakable = true
tiles[29].toolNeeded = "axe"
tiles[29].switchID = 28
tiles[29].ReplacementID = 22
tiles[29].lootID = 4
tiles[29].lootAmount = 5

tiles[30] = {}
tiles[30].name = "slate wall"
tiles[30].img = love.graphics.newImage(textureFolder .. "stone.png")
tiles[30].forecolor = {150,150,150}
tiles[30].backcolor = {50,50,50}
tiles[30].walkable = false
tiles[30].lookthrough = false
tiles[30].waterSource = false
tiles[30].artificial = true
tiles[30].breakable = true
tiles[30].toolNeeded = "pickaxe"
tiles[30].ReplacementID = 22
tiles[30].lootID = 5
tiles[30].lootAmount = 5

tiles[31] = {}
tiles[31].name = "kiln"
tiles[31].img = love.graphics.newImage(textureFolder .. "furnace.png")
tiles[31].forecolor = {150,150,150}
tiles[31].backcolor = {50,50,50}
tiles[31].walkable = false
tiles[31].lookthrough = true
tiles[31].waterSource = false
tiles[31].artificial = true
tiles[31].breakable = true
tiles[31].toolNeeded = "pickaxe"
tiles[31].perk = "smelting"
tiles[31].ReplacementID = 22
tiles[31].lootID = 5
tiles[31].lootAmount = 5

tiles[32] = {}
tiles[32].name = "stone anvil"
tiles[32].img = love.graphics.newImage(textureFolder .. "anvil.png")
tiles[32].forecolor = {50,50,50}
tiles[32].backcolor = {150,150,150}
tiles[32].walkable = false
tiles[32].lookthrough = true
tiles[32].waterSource = false
tiles[32].artificial = true
tiles[32].breakable = true
tiles[32].perk = "smithing"
tiles[32].toolNeeded = "pickaxe"
tiles[32].ReplacementID = 22
tiles[32].lootID = 5
tiles[32].lootAmount = 5

tiles[33] = {}
tiles[33].name = "workbench"
tiles[33].img = love.graphics.newImage(textureFolder .. "workbench.png")
tiles[33].forecolor = {50,50,50}
tiles[33].backcolor = {150,150,150}
tiles[33].walkable = false
tiles[33].lookthrough = true
tiles[33].waterSource = false
tiles[33].artificial = true
tiles[33].breakable = true
tiles[33].perk = "workbench"
tiles[33].toolNeeded = "axe"
tiles[33].ReplacementID = 22
tiles[33].lootID = 4
tiles[33].lootAmount = 5

tiles[34] = {}
tiles[34].name = "table"
tiles[34].img = love.graphics.newImage(textureFolder .. "workbench.png")
tiles[34].forecolor = {200,150,0}
tiles[34].backcolor = {100,50,0}
tiles[34].walkable = false
tiles[34].lookthrough = true
tiles[34].waterSource = false
tiles[34].artificial = true
tiles[34].breakable = true
tiles[34].toolNeeded = "axe"
tiles[34].ReplacementID = 22
tiles[34].lootID = 4
tiles[34].lootAmount = 5

tiles[35] = {}
tiles[35].name = "chair"
tiles[35].img = love.graphics.newImage(textureFolder .. "chair.png")
tiles[35].forecolor = {200,150,0}
tiles[35].backcolor = {100,50,0}
tiles[35].walkable = true
tiles[35].lookthrough = true
tiles[35].waterSource = false
tiles[35].artificial = true
tiles[35].breakable = true
tiles[35].toolNeeded = "axe"
tiles[35].ReplacementID = 22
tiles[35].lootID = 4
tiles[35].lootAmount = 5

tiles[36] = {}
tiles[36].name = "campfire"
tiles[36].img = love.graphics.newImage(textureFolder .. "campfire.png")
tiles[36].forecolor = {200,150,0}
tiles[36].backcolor = {100,50,0}
tiles[36].walkable = false
tiles[36].lightSource = true
tiles[36].lookthrough = true
tiles[36].waterSource = false
tiles[36].artificial = true
tiles[36].breakable = true
tiles[36].perk = "cooking"
tiles[36].toolNeeded = "axe"
tiles[36].ReplacementID = 22
tiles[36].lootID = 4
tiles[36].lootAmount = 5

tiles[37] = {}
tiles[37].name = "medicinal herb"
tiles[37].img = love.graphics.newImage(textureFolder .. "herb.png")
tiles[37].forecolor = {100,255,0}
tiles[37].backcolor = {0,200,0}
tiles[37].walkable = true
tiles[37].PreferredHeight = 40
tiles[37].PreferredTemperature = 30
tiles[37].rarity = 5
tiles[37].lookthrough = true
tiles[37].breakable = true
tiles[37].ReplacementID = 5
tiles[37].lootID = 17
tiles[37].lootAmount = 2
tiles[37].herbivoreSource = true
tiles[37].herbivoreSource = "leaves"

tiles[38] = {}
tiles[38].name = "mysterious herb"
tiles[38].img = love.graphics.newImage(textureFolder .. "herb.png")
tiles[38].forecolor = {0,255,255}
tiles[38].backcolor = {200,50,0}
tiles[38].walkable = true
tiles[38].PreferredHeight = 80
tiles[38].PreferredTemperature = 40
tiles[38].rarity = 15
tiles[38].lookthrough = true
tiles[38].breakable = true
tiles[38].ReplacementID = 15
tiles[38].lootID = 18
tiles[38].lootAmount = 2
tiles[38].herbivoreSource = true
tiles[38].herbivoreSource = "leaves"

tiles[39] = {}
tiles[39].name = "deep warm water"
tiles[39].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[39].forecolor = {10,0,200}
tiles[39].backcolor = {10,0,150}
tiles[39].walkable = false
tiles[39].PreferredHeight = 10
tiles[39].PreferredTemperature = 40
tiles[39].rarity = 1
tiles[39].lookthrough = true
tiles[39].breakable = false
tiles[39].waterSource = true
tiles[39].ReplacementID = 3
tiles[39].carnivoreSource = true
tiles[39].carnivoreType = "salmon"
tiles[39].herbivoreSource = true
tiles[39].herbivoreSource = "seaweed"

tiles[40] = {}
tiles[40].name = "deep cold water"
tiles[40].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[40].forecolor = {0,10,200}
tiles[40].backcolor = {0,10,150}
tiles[40].walkable = false
tiles[40].PreferredHeight = 10
tiles[40].PreferredTemperature = -20
tiles[40].rarity = 1
tiles[40].lookthrough = true
tiles[40].breakable = false
tiles[40].waterSource = true
tiles[40].ReplacementID = 3
tiles[40].carnivoreSource = true
tiles[40].carnivoreType = "salmon"
tiles[40].herbivoreSource = true
tiles[40].herbivoreSource = "seaweed"

tiles[41] = {}
tiles[41].name = "tomato sapling"
tiles[41].img = love.graphics.newImage(textureFolder .. "sapling.png")
tiles[41].forecolor = {50,100,0}
tiles[41].backcolor = {0,200,0}
tiles[41].walkable = true
tiles[41].timeBloom = 6 * 60
tiles[41].transformTo = 42
tiles[41].PreferredHeight = 40
tiles[41].PreferredTemperature = 20
tiles[41].rarity = 25
tiles[41].lookthrough = true
tiles[41].breakable = true
tiles[41].ReplacementID = 5

tiles[42] = {}
tiles[42].name = "tomato"
tiles[42].img = love.graphics.newImage(textureFolder .. "tomato.png")
tiles[42].forecolor = {255,0,0}
tiles[42].backcolor = {0,200,0}
tiles[42].walkable = true
tiles[42].PreferredHeight = 30
tiles[42].PreferredTemperature = 30
tiles[42].artificial = true
tiles[42].rarity = 25
tiles[42].lootID = 19
tiles[42].lootAmount = 2
tiles[42].lookthrough = true
tiles[42].breakable = true
tiles[42].ReplacementID = 5

tiles[43] = {}
tiles[43].name = "beech sapling"
tiles[43].img = love.graphics.newImage(textureFolder .. "sapling.png")
tiles[43].forecolor = {0,100,0}
tiles[43].backcolor = {0,200,0}
tiles[43].walkable = true
tiles[43].artificial = true
tiles[43].timeBloom = 6 * 60 * 24
tiles[43].transformTo = 6
tiles[43].lookthrough = true
tiles[43].breakable = true
tiles[43].ReplacementID = 5

tiles[44] = {}
tiles[44].name = "pine sapling"
tiles[44].img = love.graphics.newImage(textureFolder .. "sapling.png")
tiles[44].forecolor = {0,100,0}
tiles[44].backcolor = {0,200,0}
tiles[44].walkable = true
tiles[44].artificial = true
tiles[44].timeBloom = 6 * 60 * 24
tiles[44].transformTo = 6
tiles[44].lookthrough = true
tiles[44].breakable = true
tiles[44].ReplacementID = 11

tiles[45] = {}
tiles[45].name = "birch sapling"
tiles[45].img = love.graphics.newImage(textureFolder .. "sapling.png")
tiles[45].forecolor = {50,100,50}
tiles[45].backcolor = {0,200,0}
tiles[45].walkable = true
tiles[45].artificial = true
tiles[45].timeBloom = 6 * 60 * 24
tiles[45].transformTo = 6
tiles[45].lookthrough = true
tiles[45].breakable = true
tiles[45].ReplacementID = 12

tiles[46] = {}
tiles[46].name = "stone door (closed)"
tiles[46].img = love.graphics.newImage(textureFolder .. "doorclosed.png")
tiles[46].forecolor = {100,100,100}
tiles[46].backcolor = {200,200,200}
tiles[46].walkable = false
tiles[46].lookthrough = false
tiles[46].waterSource = false
tiles[46].artificial = true
tiles[46].breakable = true
tiles[46].toolNeeded = "pickaxe"
tiles[46].switchID = 47
tiles[46].ReplacementID = 22
tiles[46].lootID = 5
tiles[46].lootAmount = 5

tiles[47] = {}
tiles[47].name = "stone door (open)"
tiles[47].img = love.graphics.newImage(textureFolder .. "dooropen.png")
tiles[47].forecolor = {100,100,100}
tiles[47].backcolor = {200,200,200}
tiles[47].walkable = true
tiles[47].lookthrough = true
tiles[47].waterSource = false
tiles[47].artificial = true
tiles[47].breakable = true
tiles[47].toolNeeded = "pickaxe"
tiles[47].switchID = 46
tiles[47].ReplacementID = 22
tiles[47].lootID = 5
tiles[47].lootAmount = 5

tiles[48] = {}
tiles[48].name = "birch door (closed)"
tiles[48].img = love.graphics.newImage(textureFolder .. "doorclosed.png")
tiles[48].forecolor = {100,100,100}
tiles[48].backcolor = {200,200,200}
tiles[48].walkable = false
tiles[48].lookthrough = false
tiles[48].waterSource = false
tiles[48].artificial = true
tiles[48].breakable = true
tiles[48].toolNeeded = "axe"
tiles[48].switchID = 49
tiles[48].ReplacementID = 22
tiles[48].lootID = 12
tiles[48].lootAmount = 5

tiles[49] = {}
tiles[49].name = "birch door (open)"
tiles[49].img = love.graphics.newImage(textureFolder .. "dooropen.png")
tiles[49].forecolor = {255,250,200}
tiles[49].backcolor = {155,150,200}
tiles[49].walkable = true
tiles[49].lookthrough = true
tiles[49].waterSource = false
tiles[49].artificial = true
tiles[49].breakable = true
tiles[49].toolNeeded = "axe"
tiles[49].switchID = 48
tiles[49].ReplacementID = 22
tiles[49].lootID = 12
tiles[49].lootAmount = 5

tiles[50] = {}
tiles[50].name = "red brick wall"
tiles[50].img = love.graphics.newImage(textureFolder .. "stone.png")
tiles[50].forecolor = {200,0,0}
tiles[50].backcolor = {100,0,0}
tiles[50].walkable = false
tiles[50].lookthrough = false
tiles[50].waterSource = false
tiles[50].artificial = true
tiles[50].breakable = true
tiles[50].toolNeeded = "pickaxe"
tiles[50].ReplacementID = 22
tiles[50].lootID = 5
tiles[50].lootAmount = 5

tiles[51] = {}
tiles[51].name = "clay door (closed)"
tiles[51].img = love.graphics.newImage(textureFolder .. "doorclosed.png")
tiles[51].forecolor = {200,0,0}
tiles[51].backcolor = {100,0,0}
tiles[51].walkable = false
tiles[51].lookthrough = false
tiles[51].waterSource = false
tiles[51].artificial = true
tiles[51].breakable = true
tiles[51].toolNeeded = "pickaxe"
tiles[51].switchID = 52
tiles[51].ReplacementID = 22
tiles[51].lootID = 1
tiles[51].lootAmount = 5

tiles[52] = {}
tiles[52].name = "clay door (open)"
tiles[52].img = love.graphics.newImage(textureFolder .. "dooropen.png")
tiles[52].forecolor = {200,0,0}
tiles[52].backcolor = {100,0,0}
tiles[52].walkable = true
tiles[52].lookthrough = true
tiles[52].waterSource = false
tiles[52].artificial = true
tiles[52].breakable = true
tiles[52].toolNeeded = "pickaxe"
tiles[52].switchID = 51
tiles[52].ReplacementID = 22
tiles[52].lootID = 1
tiles[52].lootAmount = 5

tiles[53] = {}
tiles[53].name = "birch wall"
tiles[53].img = love.graphics.newImage(textureFolder .. "wood.png")
tiles[53].forecolor = {255,250,200}
tiles[53].backcolor = {155,150,200}
tiles[53].walkable = false
tiles[53].lookthrough = false
tiles[53].waterSource = false
tiles[53].artificial = true
tiles[53].breakable = true
tiles[53].toolNeeded = "axe"
tiles[53].ReplacementID = 22
tiles[53].lootID = 12
tiles[53].lootAmount = 5

tiles[54] = {}
tiles[54].name = "birch floor"
tiles[54].img = love.graphics.newImage(textureFolder .. "floor.png")
tiles[54].forecolor = {255,250,200}
tiles[54].backcolor = {155,150,200}
tiles[54].walkable = true
tiles[54].lookthrough = true
tiles[54].waterSource = false
tiles[54].artificial = true
tiles[54].breakable = true
tiles[54].toolNeeded = "axe"
tiles[54].ReplacementID = 22
tiles[54].lootID = 12
tiles[54].lootAmount = 5

tiles[55] = {}
tiles[55].name = "clay floor patterned #1"
tiles[55].img = love.graphics.newImage(textureFolder .. "pattern.png")
tiles[55].forecolor = {200,0,0}
tiles[55].backcolor = {100,0,0}
tiles[55].walkable = true
tiles[55].lookthrough = true
tiles[55].waterSource = false
tiles[55].artificial = true
tiles[55].breakable = true
tiles[55].toolNeeded = "pickaxe"
tiles[55].ReplacementID = 22
tiles[55].lootID = 1
tiles[55].lootAmount = 5

tiles[56] = {}
tiles[56].name = "clay floor pattern #2"
tiles[56].img = love.graphics.newImage(textureFolder .. "pattern2.png")
tiles[56].forecolor = {200,0,0}
tiles[56].backcolor = {100,0,0}
tiles[56].walkable = true
tiles[56].lookthrough = true
tiles[56].waterSource = false
tiles[56].artificial = true
tiles[56].breakable = true
tiles[56].toolNeeded = "pickaxe"
tiles[56].ReplacementID = 22
tiles[56].lootID = 1
tiles[56].lootAmount = 5

tiles[57] = {}
tiles[57].name = "clay floor pattern #3"
tiles[57].img = love.graphics.newImage(textureFolder .. "pattern3.png")
tiles[57].forecolor = {200,0,0}
tiles[57].backcolor = {100,0,0}
tiles[57].walkable = true
tiles[57].lookthrough = true
tiles[57].waterSource = false
tiles[57].artificial = true
tiles[57].breakable = true
tiles[57].toolNeeded = "pickaxe"
tiles[57].ReplacementID = 22
tiles[57].lootID = 1
tiles[57].lootAmount = 5

tiles[58] = {}
tiles[58].name = "beech floor"
tiles[58].img = love.graphics.newImage(textureFolder .. "floor.png")
tiles[58].forecolor = {200,150,0}
tiles[58].backcolor = {100,50,0}
tiles[58].walkable = true
tiles[58].lookthrough = true
tiles[58].waterSource = false
tiles[58].artificial = true
tiles[58].breakable = true
tiles[58].toolNeeded = "axe"
tiles[58].ReplacementID = 22
tiles[58].lootID = 4
tiles[58].lootAmount = 5

tiles[59] = {}
tiles[59].name = "pine floor"
tiles[59].img = love.graphics.newImage(textureFolder .. "floor.png")
tiles[59].forecolor = {200,180,0}
tiles[59].backcolor = {100,75,0}
tiles[59].walkable = true
tiles[59].lookthrough = true
tiles[59].waterSource = false
tiles[59].artificial = true
tiles[59].breakable = true
tiles[59].toolNeeded = "axe"
tiles[59].ReplacementID = 22
tiles[59].lootID = 13
tiles[59].lootAmount = 5

tiles[60] = {}
tiles[60].name = "stone floor"
tiles[60].img = love.graphics.newImage(textureFolder .. "stonefloor.png")
tiles[60].forecolor = {150,150,150}
tiles[60].backcolor = {50,50,50}
tiles[60].walkable = true
tiles[60].lookthrough = true
tiles[60].waterSource = false
tiles[60].artificial = true
tiles[60].breakable = true
tiles[60].toolNeeded = "pickaxe"
tiles[60].ReplacementID = 22
tiles[60].lootID = 5
tiles[60].lootAmount = 5

tiles[61] = {}
tiles[61].name = "eggplant sapling"
tiles[61].img = love.graphics.newImage(textureFolder .. "sapling.png")
tiles[61].forecolor = {50,100,0}
tiles[61].backcolor = {0,200,0}
tiles[61].walkable = true
tiles[61].timeBloom = 7 * 60
tiles[61].transformTo = 62
tiles[61].PreferredHeight = 40
tiles[61].PreferredTemperature = 20
tiles[61].rarity = 25
tiles[61].lookthrough = true
tiles[61].breakable = true
tiles[61].ReplacementID = 5

tiles[62] = {}
tiles[62].name = "eggplant"
tiles[62].img = love.graphics.newImage(textureFolder .. "tomato.png")
tiles[62].forecolor = {150,0,255}
tiles[62].backcolor = {0,200,0}
tiles[62].walkable = true
tiles[62].PreferredHeight = 30
tiles[62].PreferredTemperature = 30
tiles[62].artificial = true
tiles[62].rarity = 25
tiles[62].lootID = 20
tiles[62].lootAmount = 2
tiles[62].lookthrough = true
tiles[62].breakable = true
tiles[62].ReplacementID = 5

tiles[63] = {}
tiles[63].name = "cabbage sapling"
tiles[63].img = love.graphics.newImage(textureFolder .. "sapling.png")
tiles[63].forecolor = {50,100,0}
tiles[63].backcolor = {0,200,0}
tiles[63].walkable = true
tiles[63].timeBloom = 60 * 8
tiles[63].transformTo = 64
tiles[63].PreferredHeight = 40
tiles[63].PreferredTemperature = 20
tiles[63].rarity = 25
tiles[63].lookthrough = true
tiles[63].breakable = true
tiles[63].ReplacementID = 5

tiles[64] = {}
tiles[64].name = "cabbage"
tiles[64].img = love.graphics.newImage(textureFolder .. "cabbage.png")
tiles[64].forecolor = {255,255,255}
tiles[64].backcolor = {0,200,0}
tiles[64].walkable = true
tiles[64].PreferredHeight = 30
tiles[64].PreferredTemperature = 30
tiles[64].artificial = true
tiles[64].rarity = 25
tiles[64].lootID = 21
tiles[64].lootAmount = 2
tiles[64].lookthrough = true
tiles[64].breakable = true
tiles[64].ReplacementID = 5

tiles[65] = {}
tiles[65].name = "mithril"
tiles[65].img = love.graphics.newImage(textureFolder .. "ore.png")
tiles[65].backImg = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[65].forecolor = {255,255,255}
tiles[65].backcolor = {150,150,150}
tiles[65].walkable = false
tiles[65].PreferredHeight = 95
tiles[65].PreferredTemperature = 30
tiles[65].rarity = 20
tiles[65].lookthrough = false
tiles[65].breakable = true
tiles[65].toolNeeded = "pickaxe"
tiles[65].ReplacementID = 7
tiles[65].lootID = 22
tiles[65].lootAmount = 1

tiles[66] = {}
tiles[66].name = "adamantium"
tiles[66].img = love.graphics.newImage(textureFolder .. "ore.png")
tiles[66].backImg = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[66].forecolor = {255,0,255}
tiles[66].backcolor = {150,150,150}
tiles[66].walkable = false
tiles[66].PreferredHeight = 95
tiles[66].PreferredTemperature = 30
tiles[66].rarity = 20
tiles[66].lookthrough = false
tiles[66].breakable = true
tiles[66].toolNeeded = "pickaxe"
tiles[66].ReplacementID = 7
tiles[66].lootID = 8
tiles[66].lootAmount = 1

tiles[67] = {}
tiles[67].name = "beehive"
tiles[67].img = love.graphics.newImage(textureFolder .. "beehive.png")
tiles[67].forecolor = {200,255,0}
tiles[67].backcolor = {50,150,0}
tiles[67].PreferredHeight = 30
tiles[67].PreferredTemperature = 22
tiles[67].walkable = false
tiles[67].lookthrough = true
tiles[67].waterSource = false
tiles[67].artificial = false
tiles[67].breakable = true
tiles[67].perk = "beehive"
tiles[67].rarity = 40
tiles[67].toolNeeded = "pickaxe"
tiles[67].ReplacementID = 22
tiles[67].lootID = 4
tiles[67].lootAmount = 5

tiles[68] = {}
tiles[68].name = "granite mountains"
tiles[68].img = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[68].forecolor = {200,200,200}
tiles[68].backcolor = {150,0,0}
tiles[68].walkable = false
tiles[68].PreferredHeight = 90
tiles[68].PreferredTemperature = 12
tiles[68].rarity = 1
tiles[68].lookthrough = false
tiles[68].breakable = true
tiles[68].toolNeeded = "pickaxe"
tiles[68].ReplacementID = 22
tiles[68].lootID = 27
tiles[68].lootAmount = 4

tiles[69] = {}
tiles[69].name = "phyllite mountains"
tiles[69].img = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[69].forecolor = {200,200,200}
tiles[69].backcolor = {50,50,50}
tiles[69].walkable = false
tiles[69].PreferredHeight = 90
tiles[69].PreferredTemperature = 14
tiles[69].rarity = 1
tiles[69].lookthrough = false
tiles[69].breakable = true
tiles[69].toolNeeded = "pickaxe"
tiles[69].ReplacementID = 22
tiles[69].lootID = 28
tiles[69].lootAmount = 4

tiles[70] = {}
tiles[70].name = "mylonite mountains"
tiles[70].img = love.graphics.newImage(textureFolder .. "mountain.png")
tiles[70].forecolor = {255,200,200}
tiles[70].backcolor = {200,150,150}
tiles[70].walkable = false
tiles[70].PreferredHeight = 90
tiles[70].PreferredTemperature = 12
tiles[70].rarity = 1
tiles[70].lookthrough = false
tiles[70].breakable = true
tiles[70].toolNeeded = "pickaxe"
tiles[70].ReplacementID = 22
tiles[70].lootID = 27
tiles[70].lootAmount = 4

tiles[71] = {}
tiles[71].name = "granite wall"
tiles[71].img = love.graphics.newImage(textureFolder .. "stone.png")
tiles[71].forecolor = {200,200,200}
tiles[71].backcolor = {150,0,0}
tiles[71].walkable = false
tiles[71].lookthrough = false
tiles[71].waterSource = false
tiles[71].artificial = true
tiles[71].breakable = true
tiles[71].toolNeeded = "pickaxe"
tiles[71].ReplacementID = 22
tiles[71].lootID = 27
tiles[71].lootAmount = 5

tiles[72] = {}
tiles[72].name = "phyllite wall"
tiles[72].img = love.graphics.newImage(textureFolder .. "stone.png")
tiles[72].forecolor = {200,200,200}
tiles[72].backcolor = {50,50,50}
tiles[72].walkable = false
tiles[72].lookthrough = false
tiles[72].waterSource = false
tiles[72].artificial = true
tiles[72].breakable = true
tiles[72].toolNeeded = "pickaxe"
tiles[72].ReplacementID = 22
tiles[72].lootID = 28
tiles[72].lootAmount = 5

tiles[73] = {}
tiles[73].name = "mylonite wall"
tiles[73].img = love.graphics.newImage(textureFolder .. "stone.png")
tiles[73].forecolor = {255,200,200}
tiles[73].backcolor = {200,150,150}
tiles[73].walkable = false
tiles[73].lookthrough = false
tiles[73].waterSource = false
tiles[73].artificial = true
tiles[73].breakable = true
tiles[73].toolNeeded = "pickaxe"
tiles[73].ReplacementID = 22
tiles[73].lootID = 29
tiles[73].lootAmount = 5

tiles[74] = {}
tiles[74].name = "granite door (closed)"
tiles[74].img = love.graphics.newImage(textureFolder .. "doorclosed.png")
tiles[74].forecolor = {100,100,100}
tiles[74].backcolor = {200,200,200}
tiles[74].walkable = false
tiles[74].lookthrough = false
tiles[74].waterSource = false
tiles[74].artificial = true
tiles[74].breakable = true
tiles[74].toolNeeded = "pickaxe"
tiles[74].switchID = 75
tiles[74].ReplacementID = 22
tiles[74].lootID = 5
tiles[74].lootAmount = 5

tiles[75] = {}
tiles[75].name = "granite door (open)"
tiles[75].img = love.graphics.newImage(textureFolder .. "dooropen.png")
tiles[75].forecolor = {100,100,100}
tiles[75].backcolor = {200,200,200}
tiles[75].walkable = true
tiles[75].lookthrough = true
tiles[75].waterSource = false
tiles[75].artificial = true
tiles[75].breakable = true
tiles[75].toolNeeded = "pickaxe"
tiles[75].switchID = 74
tiles[75].ReplacementID = 22
tiles[75].lootID = 5
tiles[75].lootAmount = 5

tiles[76] = {}
tiles[76].name = "wooden chest"
tiles[76].img = love.graphics.newImage(textureFolder .. "chest.png")
tiles[76].forecolor = {200,150,0}
tiles[76].backcolor = {100,50,0}
tiles[76].PreferredHeight = 99
tiles[76].PreferredTemperature = 10
tiles[76].rarity = 100
tiles[76].walkable = false
tiles[76].lookthrough = true
tiles[76].waterSource = false
tiles[76].artificial = false
tiles[76].breakable = false
tiles[76].container = true
tiles[76].toolNeeded = "axe"
tiles[76].ReplacementID = 22
tiles[76].lootID = 4
tiles[76].lootAmount = 4

tiles[77] = {}
tiles[77].name = "iron cooking pot"
tiles[77].img = love.graphics.newImage(textureFolder .. "pot.png")
tiles[77].forecolor = {50,50,50}
tiles[77].backcolor = {150,150,150}
tiles[77].walkable = false
tiles[77].lookthrough = true
tiles[77].waterSource = false
tiles[77].artificial = true
tiles[77].breakable = true
tiles[77].perk = "cooking"
tiles[77].toolNeeded = "pickaxe"
tiles[77].ReplacementID = 22
tiles[77].lootID = 4
tiles[77].lootAmount = 5

tiles[78] = {}
tiles[78].name = "iron chest"
tiles[78].img = love.graphics.newImage(textureFolder .. "chest.png")
tiles[78].forecolor = {255,100,100}
tiles[78].backcolor = {255,150,150}
tiles[78].PreferredHeight = 42
tiles[78].PreferredTemperature = 40
tiles[78].rarity = 400
tiles[78].walkable = false
tiles[78].lookthrough = true
tiles[78].waterSource = false
tiles[78].artificial = false
tiles[78].breakable = true
tiles[78].container = true
tiles[78].toolNeeded = "pickaxe"
tiles[78].ReplacementID = 22
tiles[78].lootID = 9
tiles[78].lootAmount = 4

tiles[79] = {}
tiles[79].name = "mylonite door (closed)"
tiles[79].img = love.graphics.newImage(textureFolder .. "doorclosed.png")
tiles[79].forecolor = {255,200,200}
tiles[79].backcolor = {200,150,150}
tiles[79].walkable = false
tiles[79].lookthrough = false
tiles[79].waterSource = false
tiles[79].artificial = true
tiles[79].breakable = true
tiles[79].toolNeeded = "pickaxe"
tiles[79].switchID = 80
tiles[79].ReplacementID = 22
tiles[79].lootID = 5
tiles[79].lootAmount = 5

tiles[80] = {}
tiles[80].name = "mylonite door (open)"
tiles[80].img = love.graphics.newImage(textureFolder .. "dooropen.png")
tiles[80].forecolor = {255,200,200}
tiles[80].backcolor = {200,150,150}
tiles[80].walkable = true
tiles[80].lookthrough = true
tiles[80].waterSource = false
tiles[80].artificial = true
tiles[80].breakable = true
tiles[80].toolNeeded = "pickaxe"
tiles[80].switchID = 79
tiles[80].ReplacementID = 22
tiles[80].lootID = 5
tiles[80].lootAmount = 5

tiles[81] = {}
tiles[81].name = "phyllite door (closed)"
tiles[81].img = love.graphics.newImage(textureFolder .. "doorclosed.png")
tiles[81].forecolor = {200,200,200}
tiles[81].backcolor = {50,50,50}
tiles[81].walkable = false
tiles[81].lookthrough = false
tiles[81].waterSource = false
tiles[81].artificial = true
tiles[81].breakable = true
tiles[81].toolNeeded = "pickaxe"
tiles[81].switchID = 82
tiles[81].ReplacementID = 22
tiles[81].lootID = 5
tiles[81].lootAmount = 5

tiles[82] = {}
tiles[82].name = "phyllite door (open)"
tiles[82].img = love.graphics.newImage(textureFolder .. "dooropen.png")
tiles[82].forecolor = {200,200,200}
tiles[82].backcolor = {50,50,50}
tiles[82].walkable = true
tiles[82].lookthrough = true
tiles[82].waterSource = false
tiles[82].artificial = true
tiles[82].breakable = true
tiles[82].toolNeeded = "pickaxe"
tiles[82].switchID = 81
tiles[82].ReplacementID = 22
tiles[82].lootID = 5
tiles[82].lootAmount = 5

tiles[83] = {}
tiles[83].name = "mylonite floor"
tiles[83].img = love.graphics.newImage(textureFolder .. "stonefloor.png")
tiles[83].forecolor = {255,200,200}
tiles[83].backcolor = {200,150,150}
tiles[83].walkable = true
tiles[83].lookthrough = true
tiles[83].waterSource = false
tiles[83].artificial = true
tiles[83].breakable = true
tiles[83].toolNeeded = "pickaxe"
tiles[83].ReplacementID = 22
tiles[83].lootID = 5
tiles[83].lootAmount = 5

tiles[84] = {}
tiles[84].name = "phyllite floor"
tiles[84].img = love.graphics.newImage(textureFolder .. "stonefloor.png")
tiles[84].forecolor = {200,200,200}
tiles[84].backcolor = {50,50,50}
tiles[84].walkable = true
tiles[84].lookthrough = true
tiles[84].waterSource = false
tiles[84].artificial = true
tiles[84].breakable = true
tiles[84].toolNeeded = "pickaxe"
tiles[84].ReplacementID = 22
tiles[84].lootID = 5
tiles[84].lootAmount = 5

tiles[85] = {}
tiles[85].name = "granite floor"
tiles[85].img = love.graphics.newImage(textureFolder .. "stonefloor.png")
tiles[85].forecolor = {200,200,200}
tiles[85].backcolor = {150,0,0}
tiles[85].walkable = true
tiles[85].lookthrough = true
tiles[85].waterSource = false
tiles[85].artificial = true
tiles[85].breakable = true
tiles[85].toolNeeded = "pickaxe"
tiles[85].ReplacementID = 22
tiles[85].lootID = 5
tiles[85].lootAmount = 5

tiles[86] = {}
tiles[86].name = "sand"
tiles[86].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[86].forecolor = {255,255,0}
tiles[86].backcolor = {200,200,0}
tiles[86].walkable = true
tiles[86].PreferredHeight = 26
tiles[86].PreferredTemperature = 20
tiles[86].rarity = 1
tiles[86].lookthrough = true
tiles[86].breakable = true
tiles[86].ReplacementID = 22
tiles[86].lootID = 2
tiles[86].lootAmount = 4

tiles[87] = {}
tiles[87].name = "deep water"
tiles[87].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[87].forecolor = {0,50,200}
tiles[87].backcolor = {0,50,150}
tiles[87].walkable = false
tiles[87].PreferredHeight = 25
tiles[87].PreferredTemperature = 20
tiles[87].rarity = 1
tiles[87].lookthrough = true
tiles[87].breakable = false
tiles[87].waterSource = true
tiles[87].ReplacementID = 3
tiles[87].carnivoreSource = true
tiles[87].carnivoreType = "salmon"
tiles[87].herbivoreSource = true
tiles[87].herbivoreSource = "seaweed"

tiles[88] = {}
tiles[88].name = "Sarcophagus"
tiles[88].img = love.graphics.newImage(textureFolder .. "coffin.png")
tiles[88].forecolor = {200,150,0}
tiles[88].backcolor = {200,50,0}
tiles[88].PreferredHeight = 45
tiles[88].PreferredTemperature = 40
tiles[88].rarity = 100
tiles[88].walkable = false
tiles[88].lookthrough = true
tiles[88].waterSource = false
tiles[88].artificial = false
tiles[88].breakable = false
tiles[88].container = true
tiles[88].toolNeeded = "axe"
tiles[88].ReplacementID = 22
tiles[88].lootID = 4
tiles[88].lootAmount = 4

tiles[89] = {}
tiles[89].name = "ocean"
tiles[89].img = love.graphics.newImage(textureFolder .. "waves.png")
tiles[89].forecolor = {0,0,100}
tiles[89].backcolor = {0,0,50}
tiles[89].walkable = false
tiles[89].PreferredHeight = -15
tiles[89].PreferredTemperature = 0
tiles[89].rarity = 1
tiles[89].lookthrough = true
tiles[89].breakable = false
tiles[89].waterSource = true
tiles[89].ReplacementID = 3
tiles[89].carnivoreSource = true
tiles[89].carnivoreType = "salmon"
tiles[89].herbivoreSource = true
tiles[89].herbivoreSource = "seaweed"

tiles[90] = {}
tiles[90].name = "candle"
tiles[90].img = love.graphics.newImage(textureFolder .. "candle.png")
tiles[90].forecolor = {255,255,255}
tiles[90].backcolor = {50,50,50}
tiles[90].lightSource = true
tiles[90].walkable = true
tiles[90].lookthrough = true
tiles[90].breakable = true
tiles[90].artificial = true
tiles[90].ReplacementID = 22

tiles[91] = {}
tiles[91].name = "bed"
tiles[91].img = love.graphics.newImage(textureFolder .. "bed.png")
tiles[91].forecolor = {255,255,255}
tiles[91].backcolor = {50,50,50}
tiles[91].lightSource = false
tiles[91].walkable = false
tiles[91].lookthrough = true
tiles[91].toolNeeded = "axe"
tiles[91].breakable = true
tiles[91].artificial = true
tiles[91].ReplacementID = 22
tiles[91].perk = "sleep"

tiles[92] = {}
tiles[92].name = "abandoned castle"
tiles[92].img = love.graphics.newImage(textureFolder .. "castle.png")
tiles[92].forecolor = {50,50,50}
tiles[92].backcolor = {150,150,150}
tiles[92].PreferredHeight = 30
tiles[92].PreferredTemperature = 20
tiles[92].rarity = 10
tiles[92].lightSource = false
tiles[92].walkable = false
tiles[92].lookthrough = false
tiles[92].breakable = false
tiles[92].ReplacementID = 22
tiles[92].perk = "dungeon"

tiles[93] = {}
tiles[93].name = "portal to oblivion"
tiles[93].img = love.graphics.newImage(textureFolder .. "coffin.png")
tiles[93].forecolor = {255,255,0}
tiles[93].backcolor = {150,150,150}
tiles[93].lightSource = true
tiles[93].walkable = false
tiles[93].lookthrough = true
tiles[93].artificial = true
tiles[93].breakable = false
tiles[93].ReplacementID = 22
tiles[93].perk = "dungeon"

tiles[94] = {}
tiles[94].name = "solid phyllite wall"
tiles[94].img = love.graphics.newImage(textureFolder .. "stone.png")
tiles[94].forecolor = {200,200,200}
tiles[94].backcolor = {50,50,50}
tiles[94].walkable = false
tiles[94].lookthrough = false
tiles[94].waterSource = false
tiles[94].artificial = true
tiles[94].breakable = false
tiles[94].toolNeeded = "pickaxe"
tiles[94].ReplacementID = 22
tiles[94].lootID = 28
tiles[94].lootAmount = 5
end
