function love.load()
generate(false)
end

function initDungeon(width,height,floorID,wallID)
dungeon = {}
	for x = 1, width do
			dungeon[x] = {}
		for y = 1, height do
				if x == 1 or x == width or y == 1 or y == height then
				dungeon[x][y] = wallID
				else
				dungeon[x][y] = floorID
				end
		end
	end
end

function love.keypressed(key)
	if key == "r" then
		generate(true)
	end
end

function generateDungeon(randomBool,wallID,floorID,DoorID,RandomIDArray)
if randomBool then
initDungeon(math.random(40) + 80,math.random(40) + 80,floorID,wallID)
createWalls(math.random(40) + 20,wallID,DoorID)
else
generateDungeon(20,20)
createWalls(6)
end
decorate(RandomIDArray,floorID)
end

function decorate(arrayOfTiles,floorID)
	for x = 1, #dungeon do
		for y = 1, #dungeon[1] do
			if dungeon[x][y] == floorID and math.random(80) == 1 then
				dungeon[x][y] = arrayOfTiles[math.random(#arrayOfTiles)]
			end
		end
	end
end

function createWalls(amount,wallID,DoorID)
for i = 1, amount do
	if math.random(2) == 1 then
		WallPlace = math.ceil(math.random(math.floor(#dungeon[1] / 4)))
		DoorPlace = {}
		for i = 1, math.floor(amount / 4) do
		DoorPlace[i] = math.ceil(math.random(#dungeon[1] / 8) * 7)
		end
		for x = 1, #dungeon do
			for i = 1, #DoorPlace do
				if x == DoorPlace[i] then
					dungeon[x][WallPlace * 3] = DoorID
					break
				else
					dungeon[x][WallPlace * 3] = wallID
				end
			end
		end
	else
		WallPlace = math.ceil(math.random(math.floor(#dungeon / 4)))
		DoorPlace = {}
		for i = 1, math.floor(amount / 4) do
		DoorPlace[i] = math.ceil(math.random(#dungeon / 8) * 7)
		end
		for y = 1, #dungeon[1] do
			for i = 1, #DoorPlace do
				if y == DoorPlace[i] then
					dungeon[WallPlace * 3][y] = DoorID
					break
				else
					dungeon[WallPlace * 3][y] = wallID
				end
			end
		end
	end
end
end

function love.draw()
	for x = 1, #dungeon do
		for y = 1, #dungeon[1] do
				if dungeon[x][y] == 1 then
				love.graphics.setColor(255,255,255)
				elseif dungeon[x][y] == 2 then
				love.graphics.setColor(255,0,0)
				elseif dungeon[x][y] == 5 then
				love.graphics.setColor(255,255,0)
				elseif dungeon[x][y] == 7 then
				love.graphics.setColor(255,0,255)
				elseif dungeon[x][y] == 10 then
				love.graphics.setColor(0,255,255)
				end
				if dungeon[x][y] > 0 then
				love.graphics.rectangle("fill",x * 16, y * 16,16,16)
				end
				--love.graphics.print(dungeon[x][y], (x * 16) + 4, (y * 16) + 2)
		end
	end
end